﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Data;
using System.Windows.Threading;

namespace CarouselSolarSystem
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        private DispatcherTimer timer = new DispatcherTimer();
        private TimeSpan timerInterval = TimeSpan.FromSeconds(2);

        public Window1()
        {
            InitializeComponent();

            timer.Tick += new EventHandler(timer_Tick);
            timer.Interval = this.timerInterval;
            timer.Start();
        }

        void timer_Tick(object sender, EventArgs e)
        {
            this.carouselPanel.LineDown();
            this.TryLoop();
        }

        private void RadCarouselPanel_MouseDown(object sender, MouseButtonEventArgs e)
        {
            var item = e.Source as ImageWithReflection;

            if (item != null)
                this.carouselPanel.BringItemIntoView(item, true);
        }

        private void ScrollViewer_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            if (!(sender is ScrollViewer))
                return;

            this.TryLoop();
        }

        private void scrollViewer_PreviewMouseWheel(object sender, MouseWheelEventArgs e)
        {
            if (!(sender is ScrollViewer))
                return;

            this.TryLoop();
        }

        private void scrollViewer_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if (!(sender is ScrollViewer))
                return;

            this.TryLoop();
        }

        private void TryLoop()
        {
            if (this.scrollViewer.VerticalOffset == (this.scrollViewer.ExtentHeight - (double)this.carouselPanel.ItemsPerPage - 1))
            {
                this.carouselPanel.MoveBy(-this.carouselPanel.ItemsPerPage);
            }
        }
    }
}
